<?php
$transverse = $this->module()->getClientModuleConfiguration('indicator', 'transverse');
?>

<div ng-controller="measureCampainListController as self" ng-init="self.init('group-indicator', <?= $this->object ? $this->object->getId() : 'null' ?>)">
    <table-builder options="self.options" items="self.measures" class="table-builder">
		<div class="row">
			<div class="col-sm-4">
				<div class="table-filters little-panel">
					<div class="title" data-toggle="collapse" href="#filters-collapsed-measure">
						<?= $this->icon('filters', 'fa-fw') ?>
						<?= $this->translate('filters') ?>
					</div>
					<div id="filters-collapsed-measure" class="body collapse">
						<?= $this->tableFilter('__tb.apiParams.search.data.filters', $this->measureFilters([$this->from === 'project' ? 'project' : 'indicator'])); ?>
						<div class="row">
							<div class="col-xs-6">
								<button class="btn" ng-click="self.resetfullTextSearch(); __tb.resetFilters(); __tb.loadData()"><?= $this->translate('table_filter_reset_button') ?></button>
							</div>
							<div class="col-xs-6 text-right">
								<button class="btn" ng-click="self.resetfullTextSearch(); __tb.loadData()">
									<?= $this->icon('search', 'fa-fw') ?>
									<?= $this->translate('table_filter_button') ?>
								</button>
							</div>
						</div>
					</div>
				</div>
			</div>
			<div class="col-sm-4">
				<table-builder-columns></table-builder-columns>
				<span class="hidden">
					<table-builder-queries></table-builder-queries>
				</span>
			</div>
			<div class="col-sm-4">
				<div class="btn-group pull-right">
					<button class="btn btn-lg" ng-click="__tb.removeFromList()" tooltip="<?= $this->translate('tooltip_remove_from_list') ?>">
						<?= $this->icon('eraser', 'fa-fw pointer') ?>
					</button>
					<button class="btn btn-lg btn-excel" type="button" ng-click="__tb.exportExcel()" tooltip="<?= $this->translate('tooltip_export_xls') ?>">
						<?= $this->icon('excel', 'fa-fw pointer') ?>
					</button>
				</div>
				<div class="btn-group pull-right">
					<!-- <?php if ($this->acl()->isAllowed('indicator:e:measure:c')) : ?>
						<button type="button" class="btn btn-lg" ng-click="self.createMeasure()" <?= ($this->from === 'project' && $this->acl()->onlyOwned('project:e:project:u') ? 'ng-if="self.isManager(' . $this->authStorage()->getUser()->getId() . ')"' : '') ?>>
							<?= $this->icon('create') ?>
							<?= $this->translate('measure_nav_form'); ?>
						</button>
					<?php endif; ?> -->
					<button type="button" class="btn btn-lg" ng-click="showChart = !showChart" tooltip="<?= $this->translate('tooltip_show_chart') ?>">
						<i class="fa" ng-class="{
                            'fa-line-chart': !showChart,
                            'fa-list': showChart
                        }"></i>
					</button>
				</div>
			</div>
		</div>
		<div class="row" ng-show="showChart">
			<div class="col-sm-6" ng-repeat="chart in self.charts">
				<nvd3 options="chart.options" data="chart.data" api="chart.api"></nvd3>
			</div>
		</div>
		<div class="row" ng-show="!showChart">
			<div class="col-xs-12">
				<form name="measureForm">
					<table table-builder-table class="table table-bordered table-condensed table-hover">
						<thead>
							<tr>
								<th tb-column tb-name="selection" class="checkbox-column"><input type="checkbox" ng-model="__tb.selection"/></th>
								<?php if ($this->isMaster) : ?>
									<th tb-column tb-name="client" tb-sortable="true" tb-toggle="true"><?= $this->translate('measure_field_client') ?></th>
								<?php endif ?>
								<th tb-column tb-name="indicator" tb-sortable="true" tb-toggle="true"><?= $this->translate('measure_field_indicator') ?></th>
                                <th tb-column tb-name="type" tb-sortable="true" tb-toggle="true"><?= $this->translate('measure_field_type') ?></th>
								<th tb-column tb-name="start" tb-sortable="true" tb-toggle="true"><?= $this->translate('measure_field_start') ?></th>
								<th tb-column tb-name="date" tb-sortable="true" tb-toggle="true"><?= $this->translate('measure_field_date') ?></th>
								<th tb-column tb-name="value" tb-sortable="true" tb-toggle="true"><?= $this->translate('measure_field_value') ?></th>
								<th tb-column tb-name="comment" tb-sortable="true" tb-toggle="true"><?= $this->translate('measure_field_comment') ?></th>
								<th tb-column tb-name="source" tb-sortable="true" tb-toggle="true"><?= $this->translate('measure_field_source') ?></th>
								<th tb-column tb-name="campain.name" tb-sortable="true" tb-toggle="true" tb-hidden="true"><?= $this->translate('measure_field_campain') ?></th>
								<?php if ($transverse) : ?>
									<th tb-column tb-name="transverse" tb-sortable="true" tb-toggle="true"><?= $this->translate('measure_field_transverse') ?></th>
								<?php endif; ?>
								<?php if ($this->module()->isActive('project') && $this->from !== 'project') : ?>
									<th tb-column tb-name="project.name" tb-sortable="true" tb-toggle="true"><?= $this->translate('measure_field_project') ?></th>
								<?php endif; ?>
								<?php if ($this->from == 'project') : ?>
									<th tb-column tb-name="indicator.name" tb-sortable="true" tb-toggle="true" tb-hidden="true"><?= $this->translate('measure_field_indicator') ?></th>
								<?php endif; ?>
								<?php if ($this->module()->isActive('map')) : ?>
									<th tb-column tb-name="territories" tb-sortable="false" tb-toggle="true"><?= $this->translate('measure_field_territories') ?></th>
								<?php endif; ?>
								<th tb-column tb-name="createdAt" tb-sortable="true" tb-toggle="true" tb-hidden="true"><?= $this->translate('measure_field_createdAt') ?></th>
								<th tb-column tb-name="updatedAt" tb-sortable="true" tb-toggle="true" tb-hidden="true"><?= $this->translate('measure_field_updatedAt') ?></th>
								<!-- <th tb-column tb-name="actions" class="actions-column"></th> -->
							</tr>
						</thead>
						<tbody ng-repeat="(indicator, measures) in self.measures | groupBy : 'indicator.name'">
							
							<tr class="group" ng-init="data = self.getRatio(measures[0].indicator, measures)">
								<td colspan="16" class="pointer" ng-click="showMeasures = !showMeasures">
									<i class="fa fa-caret-right" ng-class="{'fa-caret-right' : !showMeasures, 'fa-caret-down' : showMeasures}"></i>
									{{indicator}}
								</td>
							</tr>
							<tr ng-repeat="measure in measures" ng-show="showMeasures" ng-class="{editing: self.editedLine == measure}">
								<td><input type="checkbox" ng-model="measure.selected"/></td>
                                <td class="editable">
                                    <span ng-show="self.editedLine !== measure">
                                        <a ng-if="measure._rights.read" href="<?= $this->url('indicator/form') ?>/{{measure.indicator.id}}">{{measure.indicator.name}}</a>
                                        <span ng-if="!measure._rights.read">{{measure.indicator.name}}</span>

                                        <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(measure)', 'ng-if' => 'measure._rights.update']) ?>
                                    </span>
                                    <span ng-if="self.editedLine == measure">
                                        <input type="text" class="form-control input-sm" ng-model="self.editedLineFields.name" required />
                                        <field-errors field="name" errors="self.editedLineErrors"></field-errors>
                                    </span>
                                </td>
								<?php if ($this->isMaster) : ?>
									<td>{{ measure.client.name }}</td>
								<?php endif ?>
								<td class="editable">
									<span ng-show="self.editedLine !== measure">
										{{'measure_type_' + measure.type | translate}}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(measure)', 'ng-if' => 'measure._rights.update']) ?>
									</span>
									<span ng-show="self.editedLine == measure">
										<select class="form-control input-sm" required
														ng-model="self.editedLineFields.type">
											<?php
											foreach (\Indicator\Entity\Measure::getTypes() as $type) {
												echo '<option value="' . $type . '">' . $this->translate('measure_type_' . $type) . '</option>';
											}
											?>
										</select>
										<field-errors field="type" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td class="editable">
									<span ng-show="self.editedLine !== measure">
										{{measure.start | dateFormat : 'DD/MM/YYYY'}}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(measure)', 'ng-if' => 'measure._rights.update']) ?>
									</span>
									<span ng-show="self.editedLine == measure">
										<input type="text" name="start" class="form-control input-sm" autocomplete="off"
													 input-mask="qdate"
													 ng-model="self.editedLineFields.start"/>
										<field-errors field="start" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td class="editable">
									<span ng-show="self.editedLine !== measure">
										{{measure.date | dateFormat : 'DD/MM/YYYY'}}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(measure)', 'ng-if' => 'measure._rights.update']) ?>
									</span>
									<span ng-show="self.editedLine == measure">
										<input type="text" name="date" class="form-control input-sm" required autocomplete="off"
													 input-mask="qdate"
													 ng-model="self.editedLineFields.date"/>
										<field-errors field="date" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td ng-style="{background: measure.fixedValue.color}" class="editable">
									<span ng-show="self.editedLine !== measure">
										{{measure.fixedValue.text}}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(measure)', 'ng-if' => 'measure._rights.update']) ?>
									</span>
									<span ng-show="self.editedLine == measure">
										<input type="text" input-mask="decimal" required class="form-control input-sm"
													 ng-if="self.editedLineFields.indicator.type == '<?= \Indicator\Entity\Indicator::TYPE_FREE ?>'" ng-model="self.editedLineFields.value"/>

										<select class="form-control input-sm" required
														ng-if="self.editedLineFields.indicator.type == '<?= \Indicator\Entity\Indicator::TYPE_FIXED ?>'" ng-model="self.editedLineFields.value"
														ng-options="+(value.value) as value.text for value in self.editedLineFields.indicator.values">
											<option></option>
										</select>

										<field-errors field="value" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td class="editable">
									<span ng-show="self.editedLine !== measure">
										{{measure.comment}}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(measure)', 'ng-if' => 'measure._rights.update']) ?>
									</span>
									<span ng-show="self.editedLine == measure">
										<input type="text"
													 class="form-control input-sm"
													 ng-model="self.editedLineFields.comment"/>

										<field-errors field="comment" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<td class="editable">
									<span ng-show="self.editedLine !== measure">
										{{measure.source}}
										<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(measure)', 'ng-if' => 'measure._rights.update']) ?>
									</span>
									<span ng-show="self.editedLine == measure">
										<input type="text"
													 class="form-control input-sm"
													 ng-model="self.editedLineFields.source"/>

										<field-errors field="source" errors="self.editedLineErrors"></field-errors>
									</span>
								</td>
								<?php if ($transverse) : ?>
									<td>
										{{ measure.transverse ? 'Oui' : ''}}
									</td>
								<?php endif; ?>
								<td>
									<a href="<?= $this->url('campain/form') ?>/{{measure.campain.id}}">{{ measure.campain.name }}</a>
								</td>
								<?php if ($this->module()->isActive('project') && $this->from !== 'project') : ?>
									<td class="editable">
										<span ng-show="self.editedLine !== measure">
											<?php if ($this->acl()->isAllowed('project:e:project:r')) : ?>
												<a href="<?= $this->url('project/form') ?>/{{measure.project.id}}">{{measure.project.name}}</a>
											<?php else : ?>
												{{measure.project.name}}
											<?php endif; ?>
											<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(measure)', 'ng-if' => 'measure._rights.update']) ?>
										</span>
										<span ng-show="self.editedLine == measure">
											<project-select name="project" required="false"
																			ng-model="self.editedLineFields.project"
																			form="measureForm"></project-select>
											<field-errors field="project" errors="self.editedLineErrors"></field-errors>
										</span>
									</td>
								<?php endif; ?>
								<?php if ($this->from == 'project') : ?>
									<td class="editable">
										<span ng-show="self.editedLine !== measure">
											<?php if ($this->acl()->isAllowed('indicator:e:indicator:r')) : ?>
												<a href="<?= $this->url('indicator/form') ?>/{{measure.indicator.id}}">{{measure.indicator.name}}</a>
											<?php else : ?>
												{{measure.indicator.name}}
											<?php endif; ?>
											<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(measure)', 'ng-if' => 'measure._rights.update']) ?>
										</span>
										<span ng-show="self.editedLine == measure">
											<indicator-select name="indicator" required="true"
																				ng-model="self.editedLineFields.indicator"
																				form="measureForm"></indicator-select>
											<field-errors field="indicator" errors="self.editedLineErrors"></field-errors>
										</span>

									</td>
								<?php endif; ?>
								<?php if ($this->module()->isActive('polluted') && $this->from !== 'polluted') : ?>
									<td class="editable">
										<span ng-show="self.editedLine !== measure">
											<?php if ($this->acl()->isAllowed('polluted:e:polluted:r')) : ?>
												<a href="<?= $this->url('polluted/form') ?>/{{measure.polluted.id}}">{{measure.polluted.name}}</a>
											<?php else : ?>
												{{measure.polluted.name}}
											<?php endif; ?>
											<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(measure)', 'ng-if' => 'measure._rights.update']) ?>
										</span>
										<span ng-show="self.editedLine == measure">
											<polluted-select name="polluted" required="false"
																			 ng-model="self.editedLineFields.polluted"
																			 form="measureForm"></polluted-select>
											<field-errors field="polluted" errors="self.editedLineErrors"></field-errors>
										</span>
									</td>
								<?php endif; ?>
								<?php if ($this->from == 'polluted') : ?>
									<td class="editable">
										<span ng-show="self.editedLine !== measure">
											<?php if ($this->acl()->isAllowed('indicator:e:indicator:r')) : ?>
												<a href="<?= $this->url('indicator/form') ?>/{{measure.indicator.id}}">{{measure.indicator.name}}</a>
											<?php else : ?>
												{{measure.indicator.name}}
											<?php endif; ?>
											<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(measure)', 'ng-if' => 'measure._rights.update']) ?>
										</span>
										<span ng-show="self.editedLine == measure">
											<indicator-select name="indicator" required="true"
																				ng-model="self.editedLineFields.indicator"
																				form="measureForm"></indicator-select>
											<field-errors field="indicator" errors="self.editedLineErrors"></field-errors>
										</span>

									</td>
								<?php endif; ?>
								<?php if ($this->module()->isActive('map')) : ?>
									<td class="editable">
										<span ng-show="self.editedLine !== measure" class="comma-separated">
											<span ng-repeat="territory in measure.territories"><!--
                                                -->{{territory.name}}<!--
                                            --></span>
											<?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(measure)', 'ng-if' => 'measure._rights.update']) ?>
										</span>
										<span ng-show="self.editedLine == measure">
											<territory-select name="territories" multiple="true"
																				ng-model="self.editedLineFields.territories"
																				form="measureForm"></territory-select>
											<field-errors field="territories" errors="self.editedLineErrors"></field-errors>
										</span>
									</td>
								<?php endif; ?>
								<td>{{measure.createdAt | dateFormat : 'DD/MM/YYYY'}}</td>
								<td>{{measure.updatedAt | dateFormat : 'DD/MM/YYYY'}}</td>
								<!-- <td>
									<div class="btn-group btn-group-actions" ng-if="self.editedLine != measure">
										<?php if ($this->acl()->isAllowed('indicator:e:measure:u')) : ?>
											<a ng-if="measure._rights.update" class="btn btn-xs btn-default" ng-click="self.editMeasure(measure);" tooltip="<?= $this->translate('tooltip_edit') ?>">
												<?= $this->icon('edit') ?>
											</a>
										<?php endif; ?>

										<?php if ($this->acl()->isAllowed('indicator:e:measure:d')) : ?>
											<a ng-if="measure._rights.delete" ng-click="self.deleteMeasure(measure);" class="btn btn-xs btn-default" tooltip="<?= $this->translate('tooltip_delete') ?>">
												<?= $this->icon('delete') ?>
											</a>
										<?php endif; ?>
									</div>
									<div class="btn-group btn-group-actions" ng-if="self.editedLine == measure">
										<button class="btn btn-xs btn-default" ng-click="self.saveEditedLine(measure)" type="submit" tooltip="<?= $this->translate('tooltip_save') ?>">
											<?= $this->icon('save') ?>
										</button>
										<button class="btn btn-xs btn-default" ng-click="self.editedLine = null" type="button" tooltip="<?= $this->translate('tooltip_cancel') ?>">
											<?= $this->icon('close') ?>
										</button>
									</div>
								</td> -->
							</tr>
						</tbody>
					</table>
				</form>
			</div>
		</div>
	</table-builder>
</div>
<?php
$this->angular('js/src/indicator/service/measure.js');

$this->angular('js/src/campain/directive/campainSelect.js');
$this->angular('js/src/campain/service/campain.js');
?>
